/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.Objects;

/**
 * Discussion
 */
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "class", visible = true )
@JsonSubTypes({
})

public class Discussion {
  @JsonProperty("class")
  private String propertyClass = null;

  @JsonProperty("closed")
  private LocalDateTime closed = null;

  @JsonProperty("closed_by")
  private Object closedBy = null;

  @JsonProperty("created")
  private LocalDateTime created = null;

  @JsonProperty("discussion")
  private DiscussionMessage discussion = null;

  @JsonProperty("extras")
  private Object extras = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("subject")
  private Object subject = null;

  @JsonProperty("title")
  private String title = null;

  @JsonProperty("url")
  private String url = null;

  @JsonProperty("user")
  private Object user = null;

  public Discussion propertyClass(String propertyClass) {
    this.propertyClass = propertyClass;
    return this;
  }

   /**
   * The object class
   * @return propertyClass
  **/
  @ApiModelProperty(required = true, value = "The object class")
  public String getPropertyClass() {
    return propertyClass;
  }

  public void setPropertyClass(String propertyClass) {
    this.propertyClass = propertyClass;
  }

  public Discussion closed(LocalDateTime closed) {
    this.closed = closed;
    return this;
  }

   /**
   * The discussion closing date
   * @return closed
  **/
  @ApiModelProperty(value = "The discussion closing date")
  public LocalDateTime getClosed() {
    return closed;
  }

  public void setClosed(LocalDateTime closed) {
    this.closed = closed;
  }

  public Discussion closedBy(Object closedBy) {
    this.closedBy = closedBy;
    return this;
  }

   /**
   * The user who closed the discussion
   * @return closedBy
  **/
  @ApiModelProperty(value = "The user who closed the discussion")
  public Object getClosedBy() {
    return closedBy;
  }

  public void setClosedBy(Object closedBy) {
    this.closedBy = closedBy;
  }

  public Discussion created(LocalDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * The discussion creation date
   * @return created
  **/
  @ApiModelProperty(value = "The discussion creation date")
  public LocalDateTime getCreated() {
    return created;
  }

  public void setCreated(LocalDateTime created) {
    this.created = created;
  }

  public Discussion discussion(DiscussionMessage discussion) {
    this.discussion = discussion;
    return this;
  }

   /**
   * Get discussion
   * @return discussion
  **/
  @ApiModelProperty(value = "")
  public DiscussionMessage getDiscussion() {
    return discussion;
  }

  public void setDiscussion(DiscussionMessage discussion) {
    this.discussion = discussion;
  }

  public Discussion extras(Object extras) {
    this.extras = extras;
    return this;
  }

   /**
   * Extra attributes as key-value pairs
   * @return extras
  **/
  @ApiModelProperty(value = "Extra attributes as key-value pairs")
  public Object getExtras() {
    return extras;
  }

  public void setExtras(Object extras) {
    this.extras = extras;
  }

  public Discussion id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The discussion identifier
   * @return id
  **/
  @ApiModelProperty(value = "The discussion identifier")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public Discussion subject(Object subject) {
    this.subject = subject;
    return this;
  }

   /**
   * The discussion target object
   * @return subject
  **/
  @ApiModelProperty(value = "The discussion target object")
  public Object getSubject() {
    return subject;
  }

  public void setSubject(Object subject) {
    this.subject = subject;
  }

  public Discussion title(String title) {
    this.title = title;
    return this;
  }

   /**
   * The discussion title
   * @return title
  **/
  @ApiModelProperty(value = "The discussion title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public Discussion url(String url) {
    this.url = url;
    return this;
  }

   /**
   * The discussion API URI
   * @return url
  **/
  @ApiModelProperty(value = "The discussion API URI")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public Discussion user(Object user) {
    this.user = user;
    return this;
  }

   /**
   * The discussion author
   * @return user
  **/
  @ApiModelProperty(value = "The discussion author")
  public Object getUser() {
    return user;
  }

  public void setUser(Object user) {
    this.user = user;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Discussion discussion = (Discussion) o;
    return Objects.equals(this.propertyClass, discussion.propertyClass) &&
        Objects.equals(this.closed, discussion.closed) &&
        Objects.equals(this.closedBy, discussion.closedBy) &&
        Objects.equals(this.created, discussion.created) &&
        Objects.equals(this.discussion, discussion.discussion) &&
        Objects.equals(this.extras, discussion.extras) &&
        Objects.equals(this.id, discussion.id) &&
        Objects.equals(this.subject, discussion.subject) &&
        Objects.equals(this.title, discussion.title) &&
        Objects.equals(this.url, discussion.url) &&
        Objects.equals(this.user, discussion.user);
  }

  @Override
  public int hashCode() {
    return Objects.hash(propertyClass, closed, closedBy, created, discussion, extras, id, subject, title, url, user);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Discussion {\n");

    sb.append("    propertyClass: ").append(toIndentedString(propertyClass)).append("\n");
    sb.append("    closed: ").append(toIndentedString(closed)).append("\n");
    sb.append("    closedBy: ").append(toIndentedString(closedBy)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    discussion: ").append(toIndentedString(discussion)).append("\n");
    sb.append("    extras: ").append(toIndentedString(extras)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    subject: ").append(toIndentedString(subject)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    user: ").append(toIndentedString(user)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

